#!/bin/sh

# setup: copy sed, grep, awk, echo, kill
# to your glftpd/bin dir.  compile ftpwho
# using cc -o ftpwho ftpwho.c and put it
# in your glftpd/bin dir.  put this script
# somewhere and chmod it to 755
# you can run it from crond with this line:
# 0-59/5 * * * * /path/to/minspeed.sh
# problems: romracer@isos.net

# /. BEGIN MODIFY

# path to glftpd w/out trailing backslash
instdir="/glftpd"

# in K/sec
dlspeedlimit=0
ulspeedlimit=0

# by setting both of the following to zero
# you have a useless script
# kill users whos download speed is less
# than dlspeedlimit.. 1 = yes, 2 = no
mindownloads=0

# kill users whos upload speed is less
# than ulspeedlimit.. not good for cable
# modems 1 = yes, 2 = no
minuploads=0

# /. END MODIFY

data=`$instdir/bin/ftpwho | $instdir/bin/grep -i "K/sec" | $instdir/bin/awk '{print $8 $2 ":" $4 ":" $11}'`

for i in $data ; do
   action=`$instdir/bin/echo $i | $instdir/bin/sed "s/:/ /g" | $instdir/bin/awk '{print $1}'`
   if [ $mindownloads = 1 ] ; then
      if [ "$action" = "Dn" ] ; then
         user=`$instdir/bin/echo $i | $instdir/bin/sed "s/:/ /g" | $instdir/bin/awk '{print $2}'`
         speed=`$instdir/bin/echo $i | $instdir/bin/sed "s/:/ /g" | $instdir/bin/awk '{print $4}' | $instdir/bin/sed "s/K\/sed//g"`
         $instdir/bin/echo -e "$user is downloading at $speed\n"
         speed=$($instdir/bin/echo $speed | $instdir/bin/sed "s/K\/sec//g")
         speed=$($instdir/bin/echo $speed | $instdir/bin/sed "s/\..*$//")
         if [ $speed -le $dlspeedlimit ] ; then
            $instdir/bin/echo -e "$user is too slow.. killing..\n"
            $instdir/bin/kill -9 `$instdir/bin/echo $i | $instdir/bin/sed "s/:/ /g" | $instdir/bin/awk '{print $3}'`
         else
            $instdir/bin/echo -e "$user is fast enough..\n"
         fi
      fi
   else
      if [ $minuploads = 1 ] ; then
         if [ "$action" = "Up" ] ; then
            user=`$instdir/bin/echo $i | $instdir/bin/sed "s/:/ /g" | $instdir/bin/awk '{print $2}'`
            speed=`$instdir/bin/echo $i | $instdir/bin/sed "s/:/ /g" | $instdir/bin/awk '{print $4}' | $instdir/bin/sed "s/K\/sed//g"`
            $instdir/bin/echo -e "$user is uploading at $speed\n"
            speed=$($instdir/bin/echo $speed | $instdir/bin/sed "s/K\/sec//g")
            speed=$($instdir/bin/echo $speed | $instdir/bin/sed "s/\..*$//")
            if [ $speed -le $ulspeedlimit ] ; then
               $instdir/bin/echo -e "$user is too slow.. killing..\n"
               $instdir/bin/kill -9 `$instdir/bin/echo $i | $instdir/bin/sed "s/:/ /g" | $instdir/bin/awk '{print $3}'`
            else
               $instdir/bin/echo -e "$user is fast enough..\n"
            fi
         fi
      fi
   fi
done
